<?php

function make_it_so_number_one() {
	global $config_vars, $settings, $internal_config, $app, $orders_imported, $customers_imported;
	
	if (isset($_REQUEST['force_unlock'])) {
		$internal_config->in_progress = 0;
		save_local_config(true);
		
		user_feedback('Unlock is successful. You will now be able to run the script.');
		return;
	}	
	
	if ($internal_config->in_progress) {
		user_feedback('You can not run this right now as another version of the script is in progress. Please try again shortly');
		return;
	} else {
		$internal_config->in_progress = 1;
		save_local_config(true);
	}
	
	//only run this when import_data=1 is in the URL
	if (!isset($_GET['import_data']) || $_GET['import_data'] != 1) {
		echo start_feedback();
		
		echo feedback_item('This system is designed to work using CRON (a scheduled task). We recommend you set up a CRON job to run every 5-15 minutes calling the following URL:');
		echo feedback_item('<strong>' . APP_URL . '?import_data=1</strong>');
		echo feedback_item('In order to run the import manually you can <a href="' . APP_URL . '?import_data=1">click here</a>. It will run a single import and then stop. In order to run another you could just refresh the page.');
		
		echo end_feedback();
		
		//unlock app
		$internal_config->in_progress = 0;
		save_local_config(true);
	
		return;
	}	
	
	$module_label = ucwords($config_vars['module']);
	
	user_feedback('Module is ' . $module_label);
	
	require_once(MODULES . $config_vars['module'] . '.class.php');
	
	$module = new $config_vars['module'](); //dynamically instantiate the class
	$module->db_connect();
	
	user_feedback('Connected to ' . $module_label . ' database');
	
	check_log_table();
	
	//create tag for orders from this shop. remember to check all orders for the old order id too
	$group_name = 'Imported by IS Sync Importer from ' . $_SERVER['SERVER_NAME'];
	$tag_id = is_query_single('ContactGroup', array('GroupName' => $group_name), false, true);
	
	//create tag category for products purchased
	$product_purchased_category_id = is_query_single('ContactGroupCategory', array('CategoryName' => 'Product Purchased'), false, true);
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	$j = 0;

	///// Get X Customers who have NEVER purchased
	if ($contacts = $module->query_contacts()) {
		user_feedback('<strong>Found ' . count($contacts) . ' unattached contact(s)</strong>');
	
		// loop customers
		foreach ($contacts as $store_customer_id=>$contact) {
			array_walk($contact, 'encode_text_for_is');
			
			$j++;
			
			echo start_feedback();
			
			echo feedback_item('Processing contact ' . $j);
		
			// if customer is in IS then update (based on date and pref in config file)
			// else insert the user into IS
			if ($contact_id = $app->addWithDupCheck($contact, 'Email')) {
				echo feedback_item('Contact added/updated (' . $contact['Email'] . '). <a href="https://' . $config_vars['is_app_name'] . '.infusionsoft.com/Contact/manageContact.jsp?view=edit&ID=' . $contact_id . '" target="_blank">View</a>');
				
				if ($result = $app->grpAssign($contact_id, $tag_id)) {
					//user_feedback('Contact ' . $i . ' group assigned ' . $result);
				}
				
				if ($result = $app->optIn($contact['Email'], 'Customer Added By API')) {
					//user_feedback('Contact ' . $i . ' correspondance opt in ' . $result);
				}
			} else {
				echo feedback_item('Failed to add/find user to the system based on the following information:');
				printr($contact);
			}
			
			if (isset($_GET['debug'])) { 
				user_feedback('<pre>' . print_r($contact, true) . '</pre>');
			}
			
			echo end_feedback();
			
			$internal_config->start_from_unattached_customer_id = ($store_customer_id > $internal_config->start_from_unattached_customer_id ? $store_customer_id:$internal_config->start_from_unattached_customer_id);
		}
		
		// end customers loop
	} else {
		$internal_config->initial_customer_sync_complete = 1; //set the script as having 'caught up' because the query to get all orders since the last ID returns nothing.
		save_local_config(true);
		
		user_feedback('<strong>Found no unattached contacts to import</strong>');
	}
	
	$customers_imported += $j;
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	///// Get X orders with a completed status
	if ($orders = $module->query_orders()) {
		$order_count = count($orders);
		
		user_feedback('Found ' . $order_count . ' completed order(s)');
		
		$orders_imported = $existing_orders = 0;
		
		// loop orders
		foreach ($orders as $i=>$order) {
			$i++; //to offset the count 0-9 to 1-10. Looks better
			
			$contact = $order['contact'];
			$order_items = $order['items'];
			$order_id = $order['order']['Id'];
			
			echo start_feedback();
			echo feedback_item('<strong>Processing order ' . $i . '/' . $order_count . ' (' . $order_id . ')</strong>');
			
			//user_feedback('<pre> ' . print_r($order, true) . '</pre>');

			//contact and job info
			
			//look for the purchaser information in IS
			if (!$contact_id = is_query_single('Contact', array('Email' => $contact['Email']))) {
				array_walk($contact, 'encode_text_for_is');
				$contact_id = $app->addWithDupCheck($contact, 'Email');
				
				echo feedback_item('Customer not seen before by IS. New customer added. ID is <a href="https://' . $config_vars['is_app_name'] . '.infusionsoft.com/Contact/manageContact.jsp?view=edit&ID=' . $contact_id . '" target="_blank">' . $contact_id . '</a>');
				
				//opt the contact into correspondance from the site
				$app->optIn($contact['Email'], 'Customer Added By API');
				
				echo feedback_item('Customer opted into email correspondance');
				
				$internal_config->total_contacts_imported++;
			} else {
				// if customer exists in IS then update
				
				// Do we want to update contacts for orders created more than 24 hours ago?
				if ($config_vars['update_old_addresses']) {
					$contact_id = $app->updateCon($contact_id, $contact);
					
					echo feedback_item('Customer exists in IS. Contact data in IS has been updated (<a href="https://' . $config_vars['is_app_name'] . '.infusionsoft.com/Contact/manageContact.jsp?view=edit&ID=' . $contact_id . '" target="_blank">' . $contact_id . '</a>)');
				} else if (!$config_vars['update_old_addresses'] && strtotime($order['order']['order_date']) > (time()-86400)) {
					$contact_id = $app->updateCon($contact_id, $contact);
					
					echo feedback_item('Customer exists in IS. Contact data in IS has been updated as the order is less than 24 hours old (<a href="https://' . $config_vars['is_app_name'] . '.infusionsoft.com/Contact/manageContact.jsp?view=edit&ID=' . $contact_id . '" target="_blank">' . $contact_id . '</a>)');
				} else {
					echo feedback_item('Customer exists in IS. Config prevents update to IS contact data for this sale (<a href="https://' . $config_vars['is_app_name'] . '.infusionsoft.com/Contact/manageContact.jsp?view=edit&ID=' . $contact_id . '" target="_blank">' . $contact_id . '</a>)');
				}
			}
			
			$app->grpAssign($contact_id, $tag_id); //add the contact to the purchased item from store tag
		
			//look for orders with the same order name
			//Universal Importer from http://www.balloontwisting.co.uk/shop - Id #: 100000010 //Legacy check. No need using wild card
			$search_url = str_replace(array('http://', 'https://', 'www.'), '', APP_URL);
			echo feedback_item('Searching for orders named like: ' . $search_url . ' - Id #: ' . $order_id);
			
			if (!$job_id = is_query_single('Job', array('JobTitle' => '%' . $search_url .' - Id #: ' . $order_id))) {
				if ($config_vars['secondary_search_format']) {
					$secondary_search_string = trim(str_replace(' - Id #: ', '', $config_vars['secondary_search_format'])) . ' - Id #: ' . $order_id;
					echo feedback_item('Secondary search for orders named like: ' . $secondary_search_string);
					
					$job_id = is_query_single('Job', array('JobTitle' => '%' . $secondary_search_string));
				}
			}
			
			if (!$job_id) {
				// Insert new order
				if ($invoice_id = $app->blankOrder($contact_id, 'IS Import: ' . $search_url . ' - Id #: ' . $order_id, date('Ymd\TH:i:s', strtotime($order['order']['order_date'])), 0, 0)) {
					$internal_config->total_orders_imported++;
			
					//get the job id for the order
					if ($job_id = is_query_single('Invoice', array('Id' => $invoice_id), array('JobId'))) {
						echo feedback_item('Invoice ID ' . $invoice_id . ', Job ID is <a target="_blank" href="https://' . $config_vars['is_app_name'] . '.infusionsoft.com/Job/manageJob.jsp?view=edit&ID=' . $job_id . '">' . $job_id . '</a>');
						
						//start of new order.. not seen before based on a name lookup
						$orders_imported++;
							
						//insert tax record
						if ($vat = $order['order']['tax_amount']) {
							if ((int)$vat > 0) {
								if ($result = $app->addOrderItem($invoice_id, 0, IS_TYPE_TAX, (float)$vat, (int)1, "VAT", "VAT")) {
									echo feedback_item('Invoice ID ' . $invoice_id . ', VAT added ' . number_format($vat, 2) . '. ' . $result);
								}
							} else {
								echo feedback_item('Invoice ID ' . $invoice_id . ', No VAT added to this order');
							}
						} else {
							echo feedback_item('Invoice ID ' . $invoice_id . ', No VAT added to this order');
						}
						
						//insert shipping record
						if ($shipping = $order['order']['shipping_amount']) {
							if ((int)$shipping > 0) {
								
								if (!$order['order']['shipping_description']) {
									$order['order']['shipping_description'] = 'Shipping';
								}				
								
								if ($result = $app->addOrderItem($invoice_id, 0, IS_TYPE_SHIPPING, (float)$shipping, (int)1, $order['order']['shipping_description'], $order['order']['shipping_description'])) {
									echo feedback_item('Invoice ID ' . $invoice_id . ', Shipping added ' . number_format($shipping, 2) . '. ' . $result);
								}
							}
						} else {
							echo feedback_item('Invoice ID ' . $invoice_id . ', No shipping added to this order');
						}
						
						//discount
						if ($discount_amount = $order['order']['discount_amount']) {
							if ($discount_amount > 0) {
								$discount_amount = (float)($discount_amount*-1);
							}
							
							if (!$order['order']['discount_description']) {
								$order['order']['discount_description'] = 'Discount';
							}
							
							if ($result = $app->addOrderItem($invoice_id, 0, IS_TYPE_DISCOUNT, (float)$discount_amount, (int)1, $order['order']['discount_description'], $order['order']['discount_description'])) {
								echo feedback_item('Invoice ID ' . $invoice_id . ', Discount added to this order ' . number_format($discount_amount, 2) . '. ' . $result);
							}
						} else {
							echo feedback_item('Invoice ID ' . $invoice_id . ', No discount added to this order');
						}
						
						//start order items loop
						foreach ($order_items as $j=>$order_item) {
							$product = $order_item['product'];
							$item = $order_item['item'];
						
							//make sure the product always has a name
							if (!@$product['ProductName']) {
								$product['ProductName'] = 'Unknown Product';
							}
							
							//get the product ID based on the name. Add/insert accordingly
							if ($product_id = is_query_single('Product', array('ProductName' => $product['ProductName']))) {
								if ($result = $app->dsUpdate("Product", $product_id, $product)) {
									echo feedback_item('Invoice ID ' . $invoice_id . ', Product ' . $product['ProductName'] . ' found and updated');
								}
							} else {
								if ($product_id = $app->dsAdd("Product", $product)) {
									echo feedback_item('Invoice ID ' . $invoice_id . ', Product ' . $product['ProductName'] . ' added with ID ' . $product_id);
								}
							}
							
							$product_tag_id = is_query_single('ContactGroup', array('GroupName' => $product['ProductName'], 'GroupCategoryId'=>$product_purchased_category_id), false, true);
							if ($result = $app->grpAssign($contact_id, $product_tag_id)) {
								echo feedback_item('Tagged as having purchased: ' . $product['ProductName']);
							}
							
							// insert order item records into IS
							$item_name = (@$item['ItemName'] ? urldecode($item['ItemName']):'Unknown Item Name');
							
							if ($result = $app->addOrderItem($invoice_id, $product_id, IS_TYPE_PRODUCT, (float)$item['PPU'], (int)$item['Qty'], $item_name, '')) {
								echo feedback_item('Invoice ID ' . $invoice_id . ', Item ' . $item['ItemName'] . ' added to order');
							}
							
							//achieve goal code. goal tracking within IS
							$call_name = 'product' . $product_id . 'Sold'; // product123sold
							$app->achieveGoal($config_vars['is_app_name'], $call_name, $contact_id);
						
						//end order items loop
						}
					} else {
						echo feedback_item('Can not find the Job ID from the Invoice ID ' . $invoice_id . '. Skipping to next row');
						continue;
					}
				} else {
					echo feedback_item('Failed to insert a new order for contact ' . $contact_id . ' using data: ' . 'IS Import: ' . $search_url . ' - Id #: ' . $order_id, date('Ymd\TH:i:s', strtotime($order['order']['order_date'])));
					continue;
				}
			} else {
				echo feedback_item('<a target="_blank" href="https://' . $config_vars['is_app_name'] . '.infusionsoft.com/Job/manageJob.jsp?view=edit&ID=' . $job_id . '">exists</a> in IS. Updating relevant information. ' . $job_id);

				$existing_orders++;
				
				//get the job id for the order
				if ($invoice_id = is_query_single('Invoice', array('JobId' => $job_id))) {
					echo feedback_item('Invoice ID ' . $invoice_id . ', Job ID is <a target="_blank" href="https://' . $config_vars['is_app_name'] . '.infusionsoft.com/Job/manageJob.jsp?view=edit&ID=' . $job_id . '">' . $job_id . '</a>');
				} else {
					echo feedback_item('Can not find the Invoice ID from the Job ID ' . $job_id . '. Skipping to next row');
					continue;
				}
			}
			
			if ($job_id) { //we do this here because only at this stage can we guarantee that job_id is populated
				//update the job info.. shipping address mainly as we can't do this using blankOrder
				
				if ($config_vars['order_status_cf_id']) {
					//_order_status_cf_id
					// ImportedOrderStatus
					//insert custom field value for order status...
					$order['job']['_' . $config_vars['order_status_cf_id']] = $order['job_status']['order_status'];
				}
				
				$app->dsUpdate("Job", $job_id, $order['job']);
			} else {
				echo feedback_item('At this stage you would have expected there to be a Job ID. Aborting. Skipping to next order');
				continue;
			}
			
			// mark order as paid
			if ($order['job_status']['order_complete']) { //if the order is 'complete' then we can mark it as paid
				if ($invoice_total = is_query_single('Invoice', array('Id' => $invoice_id), array('InvoiceTotal'))) {
					$pay_date = $app->infuDate(date('d-m-Y', strtotime($order['order']['order_date'])));
					if ($result = $app->manualPmt((int)$invoice_id, (float)$invoice_total, $pay_date, $order['order']['payment_method'], '', false)) {
						echo feedback_item('Payment made for ' . number_format($invoice_total, 2));
					}
				}
			}
			
			if (isset($_GET['debug'])) {
				user_feedback('<pre>' . print_r($order, true) . '</pre>');
			}
			
			echo end_feedback();
			
			// store latest order id in local internal config
			$internal_config->start_from_order_id = ($order_id > $internal_config->start_from_order_id ? $order_id:$internal_config->start_from_order_id);				
			
		}
		// end orders loop
		
		user_feedback('<strong>Order import complete! New Orders: ' . $orders_imported . '. Existing Orders: ' . $existing_orders . '. Unattached Contacts Imported: ' . $customers_imported . '</strong>');
	
	} else {
		$internal_config->initial_order_sync_complete = 1; //set the script as having 'caught up' because the query to get all orders since the last ID returns nothing.
		save_local_config(true);
		
		user_feedback('<strong>Found no orders to import</strong>');
	}
	
	//unlock app
	$internal_config->in_progress = 0;
	save_local_config(true);
	
	log_process($customers_imported, $orders_imported); //logs to a DB table the stats for this import
}

	function save_local_config($dont_log_save=false) {
	global $internal_config;
	
	if (!$dont_log_save) {
		$internal_config->num_executions++;
		$internal_config->script_last_run = time();
	}
			
	@file_put_contents(INTERNAL_CONFIG_PATH, json_encode($internal_config));
}

function save_config() {
	global $config_vars;
	
	$return = false;
	$content = '';
	
	$content .= '<?php' . "\n\n";
	$content .= '$config_vars = array(' . "\n";
	
	$config_items = array();
	foreach ($_POST['config'] as $key=>$value) {
		$config_items[] = '\'' . $key . '\'=>\'' . $value . '\'';
		$config_vars[$key] = $value;
	}
	
	$config_items[] = '\'auth_server_url\'=>\'' . AUTH_SERVER_URL . '\'';
	$config_items[] = '\'version_server_url\'=>\'' . VERSION_SERVER_URL . '\'';
	$config_vars['auth_server_url'] = AUTH_SERVER_URL;
	$config_vars['version_server_url'] = VERSION_SERVER_URL;
	
	$content .= implode(", \n", $config_items);
	
	$content .= ');' . "\n\n";
	$content .= '?>' . "\n";
	
	@file_put_contents(CONFIG_PATH, $content);
	chmod(CONFIG_PATH, 0777);
	
	if (count($_POST['config'])) {
		$return = true;
	}
	
	return $return;
}

?>