<?php

$msgs = array('error'=>array(), 'feedback'=>array(), 'fatal'=>array());

function add_error($error) {
	add_message($error);
}

function add_fatal_error($error) {
	add_message($error, 'fatal');
}

function add_feedback($msg) {
	add_message($msg, 'feedback');
}

function add_message($msg, $type='error') {
	global $msgs;
	
	$msgs[$type][] = $msg;
}

function check_fatal_errors() {
	global $msgs;
	return (count($msgs['fatal']));
}

function display_errors() {
	display_messages();
}

function display_feedback() {
	display_messages('feedback');
}

function display_general_messages() {
	global $msgs;
	
	ob_start();
	foreach ($msgs as $type=>$msg_array) {
		display_messages($type);
	}
	$found_msgs = ob_get_clean();
	
	if ($found_msgs) {
		echo '<div class="alert_msgs">' . $found_msgs . '</div>';
		echo '<script>jQuery(".alert_msgs").appendTo(".feedback_container")</script>';
	}
}

function user_feedback($msg, $return=false) {
	$html = '';
	$html .= '<ul class="message_response feedback">';
	$html .= '<li>' . $msg . '</li>';
	$html .= '</ul>';
	
	if ($return) {
		return $html;
	} else {
		echo $html;
	}
}

function start_feedback() {
	return '<ul class="message_response feedback">';
}

function feedback_item($msg) {
	return '<li>' . $msg . '</li>';
}

function end_feedback() {
	return '</ul>';
}

function display_messages($type='error') {
	global $msgs;
	
	if ($msgs[$type]) {
		echo '<ul class="message_response ' . $type . '">';
		
		foreach ($msgs[$type] as $msg) {
			echo '<li>' . $msg . '</li>';
		}
		
		echo '</ul>';
	}
}

function printr($arr) {
	echo '<pre>';
	print_r($arr);
	echo '</pre>';
}

function pre_slashit($string) {
	$string = '/' . ltrim($string, '/');
	
	return $string;
}

function trailingslashit($string) {
	$string = rtrim($string, '/') . '/';
	
	return $string;
}

function close_script() {
	save_local_config();
	db_close();
}

function log_process($customers=0, $orders=0) {
	$sql = 'INSERT INTO is_import_log (customers_imported, orders_imported, created_date)
		VALUES (' . (int)$customers . ', ' . (int)$orders . ', UNIX_TIMESTAMP())';
	db_query($sql);
}

function chmod_directory($path='.', $filePerm=0777, $dirPerm=0777){
	
        // Check if the path exists
        if (!file_exists($path)) {
            return(false);
        }

        // See whether this is a file
        if (is_file($path)) {
            // Chmod the file with our given filepermissions
            chmod($path, $filePerm);

        // If this is a directory...
        } elseif (is_dir($path)) {
            // Then get an array of the contents
            $foldersAndFiles = scandir($path);

            // Remove "." and ".." from the list
            $entries = array_slice($foldersAndFiles, 2);

            // Parse every result...
            foreach ($entries as $entry) {
                // And call this function again recursively, with the same permissions
                chmod_directory($path."/".$entry, $filePerm, $dirPerm);
            }

            // When we are done with the contents of the directory, we chmod the directory itself
            chmod($path, $dirPerm);
        }

}

function remove_directory($dir_path) {
    if (!is_dir($dir_path)) return false;
    
    if (substr($dir_path, strlen($dir_path) - 1, 1) != '/') {
        $dir_path .= '/';
    }
    
    $files = glob($dir_path . '*', GLOB_MARK);
    
    foreach ($files as $file) {
        if (is_dir($file)) {
            remove_directory($file);
        } else {
            unlink($file);
        }
    }
    
    rmdir($dir_path);
}

function encode_text_for_is(&$value, $key) {
    $value = utf8_encode($value);
}

?>