<?php
//IS helpers. Used to optimise the interface between this script and the IS API. Things like data requests and centrally dealing with remove throttling etc

function is_query_single($table, $query, $return_fields=false, $insert_if_false=false) {
    global $app;
    
    if (!$return_fields) {
        $return_fields = array('Id');
    }
    
    $return = $app->dsQuery($table, 1, 0, $query, $return_fields);
    
    if (empty($return)) {
        if ($insert_if_false) {
            $return = $app->dsAdd($table, $query);
        }
    } else {
        if (is_array($return)) {
            $return = array_pop($return[0]);
        } else {
            $return = false; 
        }
    }
    
    return $return;
    
}

function is_query($table, $return_fields=false, $query=false) {
    global $app;
    
    if (!$query) {
        $query = array('Id'=>'%');
    }
    
    if (!$return_fields) {
        $return_fields = array('Id');
    }
    
    $return = $app->dsQuery($table, 1000, 0, $query, $return_fields);
    
    return $return;
    
}

function is_insert($table, $insert) {
    global $app;
    
    return $app->dsAdd($table, $insert);
}

?>