<?php

if (!check_config() && ($config_vars || isset($_REQUEST['save_config']))) {
    if (isset($_REQUEST['save_config'])) {
        if (!save_config()) {
            add_fatal_error('You must fill in ALL of the fields for the config file to correctly drive the site');
        }
    } else {
        add_fatal_error('The config file is incomplete. Please enter your IS and FTP information before this script will function');
    }
}

if (!check_fatal_errors()) {
    check_upgrade_directory_permissions();
    
    if (!check_fatal_errors()) {
        set_internal_config(); //this needs to be done towards the top of the file. The system has no point of origin or basis for a call home check without it
        
        check_in_progress();
        
        if ($config_vars) {
            if (!check_fatal_errors()) {
                if (!check_zip_module()) {
                    add_fatal_error('The upgrade system that this script uses required the PHP ZIP library. Please speak to your host and ask them to enable use of the "ZipArchive" PHP class. If you need assistance please contact the vendor of this script.');
                }
                
                if ($form = get_activation_form()) {
                    add_fatal_error('In order to use this software you need to purchase a licence. If you have one already then please enter your information into the form below: ' . $form);
                } else if (!call_home()) {
                    add_fatal_error('On contacting the authentication server it seems your licence is no longer valid. Please rectify this and then your license will be remotely reactivated.');
                }
                
                if (!check_module()) {
                    add_fatal_error('We can not find the appropriate module for your site. Please make sure that the right file is at ' . MODULES . $config_vars['module'] . '.class.php');
                }
                
                if (!check_manual_throttle()) {
                    add_fatal_error('You have set the batch limit outside of recommended bounds in the config file. We recommend that the batch limit is set between 10 and 100 records in order for the imports to run effectively');
                }
                
                if (!$app = is_connect()) {
                    add_fatal_error('Can not connect to InfusionSoft. Please check the AppName (' . $appName . ') and API Key then retry');
                }
            }
        }
    }
}

?>