<?php

class magento extends module {
    
    var $prefix = '';
    var $attribute_cache = array();
    
    function db_connect() {
        require_once ('../app/Mage.php');
        
        $app = Mage::app('default');
        $config = Mage::getConfig()->getResourceConnectionConfig("default_setup");
        
        db_connect((string)$config->host, (string)$config->username, (string)$config->password, (string)$config->dbname);
        
        $this->prefix = (string)Mage::getConfig()->getTablePrefix();
    }
    
    function query_contacts($contact_id = false) {
	global $internal_config, $config_vars;
	
	$sql = 'SELECT
		    DISTINCT(ce.entity_id) AS customer_id
		    , ce.email AS email
		    , caev_fn.value AS first_name
		    , caev_ln.value AS last_name
		    , caev_cp.value AS company
		    , caev_st.value AS street
		    , caev_tw.value AS town
		    , caev_ct.value AS county
		    , caev_pc.value AS postcode
		    , caev_pn.value AS phone
		    , caev_cty.value AS country
		FROM
		    ' . $this->prefix . 'customer_entity ce
		    /*LEFT JOIN ' . $this->prefix . 'sales_flat_order sfo ON (sfo.customer_id = ce.entity_id AND sfo.status IN (\'processing\', \'complete\'))*/
		    LEFT JOIN ' . $this->prefix . 'customer_entity_int cei ON (cei.entity_id = ce.entity_id AND cei.attribute_id = 13)
		    LEFT JOIN ' . $this->prefix . 'customer_address_entity cae ON (cae.entity_id = cei.value AND cae.is_active = 1)
		    LEFT JOIN ' . $this->prefix . 'customer_address_entity_varchar caev_fn ON (caev_fn.entity_id = cae.entity_id AND caev_fn.attribute_id = 20)
		    LEFT JOIN ' . $this->prefix . 'customer_address_entity_varchar caev_ln ON (caev_ln.entity_id = cae.entity_id AND caev_ln.attribute_id = 22)
		    LEFT JOIN ' . $this->prefix . 'customer_address_entity_varchar caev_cp ON (caev_cp.entity_id = cae.entity_id AND caev_cp.attribute_id = 24)
		    LEFT JOIN ' . $this->prefix . 'customer_address_entity_text caev_st ON (caev_st.entity_id = cae.entity_id AND caev_st.attribute_id = 25)
		    LEFT JOIN ' . $this->prefix . 'customer_address_entity_varchar caev_tw ON (caev_tw.entity_id = cae.entity_id AND caev_tw.attribute_id = 26)
		    LEFT JOIN ' . $this->prefix . 'customer_address_entity_varchar caev_ct ON (caev_ct.entity_id = cae.entity_id AND caev_ct.attribute_id = 28)
		    LEFT JOIN ' . $this->prefix . 'customer_address_entity_varchar caev_pc ON (caev_pc.entity_id = cae.entity_id AND caev_pc.attribute_id = 30)
		    LEFT JOIN ' . $this->prefix . 'customer_address_entity_varchar caev_pn ON (caev_pn.entity_id = cae.entity_id AND caev_pn.attribute_id = 31)
		    LEFT JOIN ' . $this->prefix . 'customer_address_entity_varchar caev_cty ON (caev_cty.entity_id = cae.entity_id AND caev_cty.attribute_id = 27)
		WHERE ';
		    
		if (!$contact_id) {
		    $sql .= '	(
				    /*sfo.entity_id IS NULL
				    AND*/ ce.entity_id > ' . (int)$internal_config->start_from_unattached_customer_id . '
				) ';
				    
		    if ((int)$internal_config->initial_customer_sync_complete && $internal_config->script_last_run) {
			$sql .= ' OR (
				    ce.updated_at != ""
				    AND ce.updated_at > "' . date('Y-m-d H:i:s', $internal_config->script_last_run) . '"
				) ';
		    }				    
				    
		    $sql .= '
			    ORDER BY ce.entity_id
			    LIMIT ' . $config_vars['batch_limit'];
		} else {
		    $sql .= ' ce.entity_id = ' . $contact_id . '
			    ORDER BY ce.entity_id DESC
			    LIMIT 1';
		}
		
	$return = array();
	
	if (isset($_GET['debug']) && !$contact_id) {
	    user_feedback('<pre>' . $sql . '</pre>');
	}	
	
        if ($clients = db_get_rows($sql)) {
	    
            foreach ($clients as $client) {
                $return[$client['customer_id']] = array(
		    'FirstName'=>$client['first_name']
		    , 'LastName'=>$client['last_name']
		    , 'Company'=>$client['company']
		    , 'Email'=>$client['email']
		    , 'Phone1'=>$client['phone']
		    , 'StreetAddress1'=>$client['street']
		    , 'City'=>$client['town']
		    , 'State'=>$client['county']
		    , 'Country'=>$client['country']
		    , 'PostalCode'=>$client['postcode']
		);
            }
        }
	
	if (isset($_GET['debug']) && !$contact_id) {
	    user_feedback('<pre>' . print_r($return, true) . '</pre>');
	}
	
	return $return;
    }
    
    function query_orders() {
        global $internal_config, $config_vars;
        
        $return = array();
        
	$sql_order = 'SELECT
			sf.increment_id AS Id
			, sf.status as order_status1
			, sf.created_at AS order_date
			, sf.updated_at AS order_date_updated
			, IF (sf.`status` IN ("processing", "complete"), 1, 0) AS order_complete
			, ce.entity_id AS customer_id
			, IF (ce.email IS NOT NULL, ce.email, IF (sfa_b.email IS NOT NULL, sfa_b.email, IF (sfa_s.email IS NOT NULL, sfa_s.email, sf.customer_email))) AS email
			, IF (sfa_b.firstname IS NOT NULL, sfa_b.firstname, sfa_s.firstname) AS first_name
			, IF (sfa_b.middlename IS NOT NULL, sfa_b.middlename, sfa_s.middlename) AS middle_name
			, IF (sfa_b.lastname IS NOT NULL, sfa_b.lastname, sfa_s.lastname) AS last_name
			, IF (sfa_b.company IS NOT NULL, sfa_b.company, sfa_s.company) AS company
			, sfa_b.street AS address_1
			, sfa_b.city
			, IF (sfa_b.region IS NOT NULL, sfa_b.region, sfa_s.region) AS region
			, IF (sfa_b.postcode IS NOT NULL, sfa_b.postcode, sfa_s.postcode) AS zip
			, IF (sfa_s.firstname IS NOT NULL, sfa_s.firstname, sfa_b.firstname) AS s_first_name
			, IF (sfa_s.middlename IS NOT NULL, sfa_s.middlename, sfa_b.middlename) AS s_middle_name
			, IF (sfa_s.lastname IS NOT NULL, sfa_s.lastname, sfa_b.lastname) AS s_last_name
			, IF (sfa_s.company IS NOT NULL, sfa_s.company, sfa_b.company) AS s_company
			, sfa_s.street AS s_address_1
			, sfa_s.city AS s_city
			, IF (sfa_s.region IS NOT NULL, sfa_s.region, sfa_b.region) AS s_region
			, IF (sfa_s.postcode IS NOT NULL, sfa_s.postcode, sfa_b.postcode) AS s_zip
			, IF (sfa_b.telephone IS NOT NULL, sfa_b.telephone, sfa_s.telephone) AS phone_1
			, IF (sfa_s.telephone IS NOT NULL, sfa_s.telephone, sfa_b.telephone) AS s_phone_1
			, IF (sfa_b.fax IS NOT NULL, sfa_b.fax, sfa_s.fax) AS fax_1
			, IF (sfa_s.fax IS NOT NULL, sfa_s.fax, sfa_b.fax) AS s_fax_1
			, sfa_b.country_id AS country_name
			, sfa_s.country_id AS s_country_name
			, sf.customer_note AS customer_notes
			, sf_p.method AS payment_method
                        , IF (sf.shipping_description IS NOT NULL, sf.shipping_description, "Shipping") AS shipping_description
			, sf.shipping_amount AS shipping_amount
                        , sf.tax_amount AS tax_amount
                        , IF (sf.discount_description IS NOT NULL, sf.discount_description, "Discount") AS discount_description
			, (sf.discount_amount * -1) AS discount_amount
		    FROM
			' . $this->prefix . 'sales_flat_order sf
			LEFT JOIN ' . $this->prefix . 'sales_flat_order_address sfa_b ON (
			    sfa_b.entity_id = sf.billing_address_id
			)
			LEFT JOIN ' . $this->prefix . 'sales_flat_order_address sfa_s ON (
			    sfa_s.entity_id = sf.shipping_address_id
			)
			LEFT JOIN ' . $this->prefix . 'customer_entity ce ON (
			    sfa_b.customer_id = ce.entity_id
			)
			LEFT JOIN ' . $this->prefix . 'sales_flat_order_payment sf_p ON (
			    sf_p.parent_id = sf.entity_id
			)
		    WHERE
			    (
				sf.increment_id > ' . (int)$internal_config->start_from_order_id;
	
	if ((int)$internal_config->initial_order_sync_complete && $internal_config->script_last_run) {
	    $sql_order .= ' OR (
				sf.updated_at != ""
				AND sf.updated_at > "' . date('Y-m-d H:i:s', $internal_config->script_last_run) . '"
			    )';
	}
	
	$sql_order .= ' )		    
                    ORDER BY sf.increment_id ASC
                    LIMIT ' . $config_vars['batch_limit'];
		    
	if (isset($_GET['debug'])) {
	    user_feedback('<pre>' . $sql_order . '</pre>');
	}		    
		    
        if ($orders = db_get_rows($sql_order)) {
            foreach ($orders as $order) {
                $order_complete = array();
		
		$contact = $this->query_contacts($order['customer_id']);
                
                $order_complete['contact'] = array(
		    'FirstName'=>$order['first_name']
		    , 'MiddleName'=>$order['middle_name']
		    , 'LastName'=>$order['last_name']
		    , 'Company'=>$order['company']
		    , 'Email'=>$order['email']
		    , 'Phone1'=>$order['phone_1']
		    , 'Fax1'=>$order['fax_1']
		    , 'StreetAddress1'=>$order['address_1']
		    , 'City'=>$order['city']
		    , 'State'=>$order['region']
		    , 'PostalCode'=>$order['zip']
		    , 'Address2Street1'=>$order['s_address_1']
		    , 'City2'=>$order['s_city']
		    , 'State2'=>$order['s_region']
		    , 'Country2'=>$order['s_country_name']
		    , 'PostalCode2'=>$order['s_zip']
		);
		
                $order_complete['job'] = array(
		    'JobNotes'=>$order['customer_notes']
		    , 'ShipFirstName'=>$order['s_first_name']
		    , 'ShipMiddleName'=>$order['s_middle_name']
		    , 'ShipLastName'=>$order['s_last_name']
		    , 'ShipCompany'=>$order['s_company']
		    , 'ShipPhone'=>$order['s_phone_1']
		    , 'ShipStreet1'=>$order['s_address_1']
		    , 'ShipCity'=>$order['s_city']
		    , 'ShipCountry'=>$order['s_country_name']
		    , 'ShipState'=>$order['s_region']
		    , 'ShipZip'=>$order['s_zip']
		);
		
		$order_complete['job_status']['order_status'] = $order['order_status1'];
		$order_complete['job_status']['order_complete'] = $order['order_complete'];
		$order_complete['job_status']['orders_status_id'] = $order['order_status1'];
		$order_complete['job_status']['order_modified'] = $order['order_date_updated'];		
		
                $order_complete['order'] = $order;
                $order_complete['items'] = $this->query_order_items($order['Id']);

		//printr($order_complete);
		
                $return[] = $order_complete;
            }
        }
	
	if (isset($_GET['debug'])) {
	    user_feedback('<pre>' . print_r($return, true) . '</pre>');
	}	
			
	return $return;
    }
    
    function query_order_items($order_id) {
        $sql = 'SELECT
                    sf_i.product_id AS magento_product_id
                    , sf_i.`name` AS order_item_name
                    , CONVERT(sf_i.qty_ordered, UNSIGNED INTEGER) AS product_quantity
                    , ROUND(sf_i.original_price, 2) AS product_item_price
                    , c1.sku AS product_sku
		    , c2.value AS product_price
		    , c3.value AS product_weight
		    , c4.value AS product_description
		    , c5.value AS product_name
                FROM
                    ' . $this->prefix . 'sales_flat_order sf
                    JOIN ' . $this->prefix . 'sales_flat_order_item sf_i ON (sf_i.order_id = sf.entity_id)
                    JOIN ' . $this->prefix . 'catalog_product_entity c1 ON (c1.entity_id = sf_i.product_id)
                    LEFT OUTER JOIN ' . $this->prefix . 'catalog_product_entity_decimal c2
                            ON c1.entity_id = c2.entity_id AND c2.attribute_id = ' . $this->get_magento_attribute('price','catalog_product') . '
                    LEFT OUTER JOIN ' . $this->prefix . 'catalog_product_entity_decimal c3
                            ON c1.entity_id = c3.entity_id AND c3.attribute_id = ' . $this->get_magento_attribute('weight','catalog_product') . '
                    LEFT OUTER JOIN ' . $this->prefix . 'catalog_product_entity_text c4
                            ON c1.entity_id = c4.entity_id AND c4.attribute_id = ' . $this->get_magento_attribute('description','catalog_product') . '
                    LEFT OUTER JOIN ' . $this->prefix . 'catalog_product_entity_varchar c5
                            ON c1.entity_id = c5.entity_id AND c5.attribute_id = ' . $this->get_magento_attribute('name','catalog_product') . '
                WHERE sf.increment_id = ' . $order_id;
		
	$return = array();
	
        if ($order_items = db_get_rows($sql)) {
	    
            foreach ($order_items as $order_item) {
		$order_item_row = array();
		
		$order_item_row['product'] = array(
		    'ProductName'=>$order_item['product_name']
		    , 'Description'=>$order_item['product_description']
		    , 'ProductPrice'=>(double)$order_item['product_price']
		    , 'Sku'=>$order_item['product_sku']
		    , 'Weight'=>$order_item['product_weight']
		    , 'Status'=>1
		);
		
		//OrderId, ProductId, ItemName, Qty, CPU (???), PPU (???), ItemDescription, ItemType, Notes
		
                $order_item_row['item'] = array(
		    'ItemName'=>$order_item['order_item_name']
		    , 'PPU'=>$order_item['product_item_price']
		    , 'Qty'=>$order_item['product_quantity']
		);
		
		$return[] = $order_item_row;
            }
        }
	
	return $return;    
    }
    
    // Get Magento attribute from DB (very helpful function for working with Magentos painfully akward DB scheme)
    function get_magento_attribute($attrib, $entity_type) {
        $result = -1;
        $attrib = trim(strtolower($attrib));
        $entity_type = trim(strtolower($entity_type));
        
        if (!count($this->attribute_cache)) {
            $sql = 'SELECT
                            a.attribute_id AS Id
                            , CONCAT(t.entity_type_code, "/", a.attribute_code) AS attribcode
                            , a.entity_type_id, a.attribute_code, a.frontend_label
                            , t.entity_type_code
                            , t.entity_table
                    FROM
                        ' . $this->prefix . 'eav_attribute a 
                        INNER JOIN ' . $this->prefix . 'eav_entity_type t ON (a.entity_type_id = t.entity_type_id)
                    ORDER BY 2';
		    
            if ($attributes = db_get_rows($sql)) {
                foreach ($attributes as $attribute) {
                    $this->attribute_cache[ $attribute['attribcode'] ] = $attribute['Id'];
                }
            }
        }
	
        if (isset($this->attribute_cache[$entity_type . '/' . $attrib])) {
            $result = $this->attribute_cache[$entity_type . '/' . $attrib];
        }
        
        return $result;
    }    
    
}

?>