<?php

class zencart extends module {
    
    var $prefix = '';
    var $attribute_cache = array();
    
    function db_connect() {
        require_once ('../includes/configure.php');
        
        db_connect(DB_SERVER, DB_SERVER_USERNAME, DB_SERVER_PASSWORD, DB_DATABASE);
        
        $this->prefix = DB_PREFIX;
    }
    
    function query_contacts($contact_id = false) {
	global $internal_config, $config_vars;
	
	$sql = 'SELECT c.customers_id AS Id, 
			c.customers_firstname AS first_name, 
			c.customers_lastname AS last_name, 
			c.customers_email_address AS email, 
			a.entry_company AS company, 
			a.entry_street_address AS address_1, 
			a.entry_suburb AS address_2, 
			a.entry_postcode AS zip, 
			a.entry_city AS city, 
			IF (a.entry_state != "", a.entry_state, z.zone_name) AS state, 
			c.customers_telephone AS phone_1, 
			c.customers_fax AS fax_1,
			co.countries_name AS country
		FROM
			' . $this->prefix . 'customers c
			LEFT JOIN ' . $this->prefix . 'customers_info ci ON (c.customers_id = ci.customers_info_id)
			/*LEFT JOIN ' . $this->prefix . 'orders o ON (c.customers_id = o.customers_id AND o.orders_status IN (2, 3, 4))*/
			LEFT JOIN ' . $this->prefix . 'address_book a ON (c.customers_default_address_id = a.address_book_id)
			LEFT JOIN ' . $this->prefix . 'countries co ON (co.countries_id = a.entry_country_id)
			LEFT JOIN ' . $this->prefix . 'zones z ON (z.zone_id = a.entry_zone_id)
		WHERE ';
		    
		if (!$contact_id) {
		    $sql .= '(
				/*o.orders_id IS NULL
				AND*/ c.customers_id > ' . (int)$internal_config->start_from_unattached_customer_id . '
			    ) ';
				    
		    if ((int)$internal_config->initial_customer_sync_complete && $internal_config->script_last_run) {
			$sql .= 'OR (
				    ci.customers_info_date_account_last_modified != ""
				    AND ci.customers_info_date_account_last_modified > "' . date('Y-m-d H:i:s', $internal_config->script_last_run) . '"
				)';
		    }
		    
		    $sql .= ' ORDER BY c.customers_id
			    LIMIT ' . $config_vars['batch_limit'];
		} else {
		    $sql .= ' c.customers_id = ' . $contact_id . '
			    ORDER BY c.customers_id DESC
			    LIMIT 1';
		}
		
	$return = array();
	
	if (isset($_GET['debug']) && !$contact_id) {
	    user_feedback('<pre>' . $sql . '</pre>');
	}		
	
        if ($clients = db_get_rows($sql)) {
            foreach ($clients as $client) {
                $return[$client['Id']] = array(
		    'FirstName'=>$client['first_name']
		    , 'LastName'=>$client['last_name']
		    , 'Company'=>$client['company']
		    , 'Email'=>$client['email']
		    , 'Phone1'=>$client['phone_1']
		    , 'Fax1'=>$client['fax_1']
		    , 'StreetAddress1'=>$client['address_1']
		    , 'StreetAddress2'=>$client['address_2']
		    , 'City'=>$client['city']
		    , 'State'=>$client['state']
		    , 'Country'=>$client['country']
		    , 'PostalCode'=>$client['zip']
		);
            }
        }
	
	if (isset($_GET['debug']) && !$contact_id) {
	    user_feedback('<pre>' . print_r($return, true) . '</pre>');
	}	
	
	return $return;
    }
    
    function query_orders() {
        global $internal_config, $config_vars;
        
        $return = array();
        
	$sql_order = '  SELECT o.orders_id AS Id, 
			    o.date_purchased AS order_date, 
			    o.customers_id AS customer_id,
			    o.order_tax AS tax_amount,
			    ot.`value` AS shipping_amount,
			    o.shipping_method AS shipping_description,
			    o.payment_module_code AS payment_method,
			    c.coupon_amount AS discount_amount,
			    os.orders_status_name AS order_status,
			    IF (o.orders_status IN (2,3), 1, 0) AS order_complete,
			    o.orders_status AS orders_status_id,
			    o.last_modified AS order_modified,
			    (SELECT comments
				    FROM ' . $this->prefix . 'orders_status_history o2
				    WHERE o2.orders_id = o.orders_id
				    ORDER BY orders_status ASC
				    LIMIT 1
			    ) AS order_notes,
			    o.customers_email_address AS email,
			    o.customers_telephone AS telephone, 
			    SUBSTRING_INDEX(SUBSTRING_INDEX(o.delivery_name, " ", 1), " ", -1) AS fname,
			    SUBSTRING_INDEX(SUBSTRING_INDEX(o.delivery_name, " ", 2), " ", -1) AS lname,
			    o.delivery_company AS company, 
			    o.delivery_street_address AS address_1, 
			    o.delivery_suburb AS address_2, 
			    o.delivery_city AS city, 
			    o.delivery_postcode AS zip, 
			    o.delivery_country AS country_name, 
			    o.delivery_state AS state_name, 
			    SUBSTRING_INDEX(SUBSTRING_INDEX(o.billing_name, " ", 1), " ", -1) AS billing_fname,
			    SUBSTRING_INDEX(SUBSTRING_INDEX(o.billing_name, " ", 2), " ", -1) AS billing_lname,
			    IF (o.billing_company != "", o.billing_company, o.customers_company) AS bill_company, 
			    IF (o.billing_street_address != "", o.billing_street_address, o.customers_street_address) AS bill_address_1, 
			    IF (o.billing_suburb != "", o.billing_suburb, o.customers_suburb) AS bill_address_2, 
			    IF (o.billing_city != "", o.billing_city, o.customers_city) AS bill_city, 
			    IF (o.billing_postcode != "", o.billing_postcode, o.customers_postcode) AS bill_zip, 
			    IF (o.billing_state != "", o.billing_state, o.customers_state) AS bill_state, 
			    IF (o.billing_country != "", o.billing_country, o.customers_country) AS bill_country
			FROM
			    ' . $this->prefix . 'orders o
			    JOIN ' . $this->prefix . 'orders_status os ON (
				o.orders_status = os.orders_status_id
				AND os.language_id = 1
			    )
			    LEFT JOIN ' . $this->prefix . 'orders_total ot ON (
				ot.orders_id = o.orders_id
				AND ot.class = "ot_shipping"
			    )
			    LEFT JOIN ' . $this->prefix . 'coupons c ON (
				o.coupon_code = c.coupon_code
			    )
			WHERE
			    (
				o.orders_id > ' . (int)$internal_config->start_from_order_id;
	
	if ((int)$internal_config->initial_order_sync_complete && $internal_config->script_last_run) {
	    $sql_order .= ' OR (
				o.last_modified != ""
				AND o.last_modified > "' . date('Y-m-d H:i:s', $internal_config->script_last_run) . '"
			    )';
	}
	
	$sql_order .= ' )
			ORDER BY o.orders_id
			LIMIT ' . $config_vars['batch_limit'];
			
	if (isset($_GET['debug'])) {
	    user_feedback('<pre>' . $sql_order . '</pre>');
	}			
		    
        if ($orders = db_get_rows($sql_order)) {
            foreach ($orders as $order) {
                $order_complete = array();
		
		$contact = $this->query_contacts($order['customer_id']);
                
                $order_complete['contact'] = array(
		    'FirstName'=>$order['billing_fname']
		    , 'LastName'=>$order['billing_lname']
		    , 'Company'=>$order['bill_company']
		    , 'Email'=>$order['email']
		    , 'Phone1'=>$order['telephone']
		    , 'StreetAddress1'=>$order['bill_address_1']
		    , 'StreetAddress2'=>$order['bill_address_2']
		    , 'City'=>$order['bill_city']
		    , 'State'=>$order['bill_state']
		    , 'Country'=>$order['bill_country']
		    , 'PostalCode'=>$order['bill_zip']
		    , 'Address2Street1'=>$order['address_1']
		    , 'Address2Street2'=>$order['address_2']
		    , 'City2'=>$order['city']
		    , 'State2'=>$order['state_name']
		    , 'Country2'=>$order['country_name']
		    , 'PostalCode2'=>$order['zip']
		);
		
                $order_complete['job'] = array(
		    'JobNotes'=>$order['order_notes']
		    , 'ShipFirstName'=>$order['fname']
		    , 'ShipLastName'=>$order['lname']
		    , 'ShipCompany'=>$order['company']
		    , 'ShipPhone'=>$order['telephone']
		    , 'ShipStreet1'=>$order['address_1']
		    , 'ShipStreet2'=>$order['address_2']
		    , 'ShipCity'=>$order['city']
		    , 'ShipCountry'=>$order['country_name']
		    , 'ShipState'=>$order['state_name']
		    , 'ShipZip'=>$order['zip']
		);
		
		$order_complete['job_status']['order_status'] = $order['order_status'];
		$order_complete['job_status']['order_complete'] = $order['order_complete'];
		$order_complete['job_status']['orders_status_id'] = $order['orders_status_id'];
		$order_complete['job_status']['order_modified'] = $order['order_modified'];
		
                $order_complete['order'] = $order;
                $order_complete['items'] = $this->query_order_items($order['Id']);

		
		//printr($order_complete);
		
                $return[] = $order_complete;
            }
        }
	
	if (isset($_GET['debug'])) {
	    user_feedback('<pre>' . print_r($return, true) . '</pre>');
	}	
	
	//printr($return);
	return $return;
    }
    
    function query_order_items($order_id) {
	$sql = 'SELECT
		    op.products_id AS zencart_product_id, 
		    op.products_name AS order_item_name, 
		    op.products_price AS product_item_price, 
		    op.products_quantity AS product_quantity, 
		    IF (pd.products_name IS NOT NULL, pd.products_name, op.products_name) AS product_name, 
		    IF (p.products_price IS NOT NULL, p.products_price, op.products_price) AS product_price, 
		    p.products_weight AS product_weight, 
		    p.products_status AS product_status,
		    pd.products_description AS product_description, 
		    p.products_model AS product_sku
		FROM
		    ' . $this->prefix . 'orders o
		    LEFT JOIN ' . $this->prefix . 'orders_products op ON (o.orders_id = op.orders_id)
		    LEFT JOIN ' . $this->prefix . 'products p ON (op.products_id = p.products_id)
		    LEFT JOIN ' . $this->prefix . 'products_description pd ON (
			pd.products_id = p.products_id
			AND pd.language_id = 1
		    )
		WHERE o.orders_id = ' . $order_id;
		
	$return = array();
	
        if ($order_items = db_get_rows($sql)) {
	    
            foreach ($order_items as $order_item) {
		$order_item_row = array();
		
		$order_item_row['product'] = array(
		    'ProductName'=>$order_item['product_name']
		    , 'Description'=>$order_item['product_description']
		    , 'ProductPrice'=>(double)$order_item['product_price']
		    , 'Sku'=>$order_item['product_sku']
		    , 'Weight'=>$order_item['product_weight']
		    , 'Status'=>1
		);
		
                $order_item_row['item'] = array(
		    'ItemName'=>$order_item['order_item_name']
		    , 'PPU'=>$order_item['product_item_price']
		    , 'Qty'=>$order_item['product_quantity']
		);
		
		$return[] = $order_item_row;
            }
        }
	
	//printr($return);
	
	return $return;    
    }  
    
}

?>