<?php

define('VERSION_NUMBER', '2.0'); //change for each version

$config_vars = array();

$server_protocol = 'https://';
if ($_SERVER['SERVER_PORT'] == 80) {
        $server_protocol = 'http://';
}

set_time_limit(0);
ob_implicit_flush(true);

ini_set('error_reporting', E_ERROR);
ini_set('display_errors', "1");
ini_set('display_startup_errors', "0");

define('INTERNAL_CONFIG_PATH', 'internal_config.json');
define('CONFIG_PATH', 'config.php');

define('AUTH_SERVER_URL', 'http://www.informationstreet.com');
define('VERSION_SERVER_URL', 'http://www.informationstreet.com');

define('APP_URL', $server_protocol . $_SERVER['HTTP_HOST'] . str_replace($_SERVER['DOCUMENT_ROOT'], '', dirname($_SERVER['SCRIPT_FILENAME'])) . '/');

define('FUNCTIONS', INCLUDES . 'functions/');
define('ISDK', INCLUDES . 'iSDK/');
define('MODULES', INCLUDES . 'modules/');
define('IMAGES_URL', APP_URL . 'includes/images/');
define('CSS_URL', APP_URL . 'includes/css/');

define('IS_TYPE_FINANCECHARGE', 6);
define('IS_TYPE_PRODUCT', 4);
define('IS_TYPE_SERVICE', 3);
define('IS_TYPE_SHIPPING', 1);
define('IS_TYPE_SPECIAL', 7);
define('IS_TYPE_TAX', 2);
define('IS_TYPE_UNKNOWN', 0);
define('IS_TYPE_UPSELL', 5);
define('IS_TYPE_DISCOUNT', 11);

@include_once('config.php'); //where the constants need to go. Simple enough for EVEN a client to complete

$settings = array();
$settings['copyright_name'] = 'Information Street';
$settings['product_name'] = 'Infusionsoft Sync Importer';

$isApp = $config_vars['is_app_name'];
$isKey = $config_vars['is_api_key'];

//Don't touch this section
$product_id = 'is_sync_importer';
$db = false;
$customers_imported = 0;
$orders_imported = 0;
$internal_config = new stdClass();
//end don't touch

require_once(FUNCTIONS . 'helper_functions.php'); //helper function dump. core of the script but only in making it run and not relevant to the functionality itself
require_once(FUNCTIONS . 'db_functions.php'); //db function dump. db not active until after the module has hooked it in
require_once(MODULES . 'module.class.php');
require_once(ISDK . 'isdk.php'); //IS SDK for API functionality
require_once(FUNCTIONS . 'is_functions.php'); //called AFTER iSDK for obvious reasons
require_once(INCLUDES . 'functions.php'); //function dump
require_once(FUNCTIONS . 'check_functions.php'); //functions to power this page but NOT used anywhere else in the system
require_once(INCLUDES . 'init.php'); //setting up and checking. Output and some processing below

?>